{\rtf1\ansi\ansicpg1252\cocoartf1671\cocoasubrtf600
{\fonttbl\f0\fswiss\fcharset0 Helvetica;}
{\colortbl;\red255\green255\blue255;}
{\*\expandedcolortbl;;}
\margl1440\margr1440\vieww10800\viewh8400\viewkind0
\pard\tx720\tx1440\tx2160\tx2880\tx3600\tx4320\tx5040\tx5760\tx6480\tx7200\tx7920\tx8640\pardirnatural\partightenfactor0

\f0\fs24 \cf0 ; int_inc_dec.a51 try interrupt, under SiLabs rev'd 4/11, rev'd 4/20 for altered ports\
\
; should increment display each time interrupted by INT0, decrement for INT1\
\
	$NOSYMBOLS													; keeps listing short..\
	$INCLUDE (C:\\MICRO\\8051\\RAISON\\INC\\c8051f410.inc) \
	$INCLUDE (C:\\MICRO\\8051\\RAISON\\INC\\VECTORS320.INC)	; Tom's vectors definition file\
\
	STACKBOT EQU 080h					; put stack at start of scratch indirectly-addressable block (80h and up)\
\
	DISPLAY EQU P2  	; port assignment altered, 4/20, to permit use of P0 for interrupt, P1 as input\
\
	; INTO* is P0.5\
	; INT1* is P0.7\
\
	ORG 0h\
	LJMP STARTUP\
\
	ORG 0D0h\
				\
STARTUP: MOV SP, #STACKBOT-1\
\
	acall USUAL_SETUP\
\
	CLR A			; (for clean startup, as usual)\
\
	acall INT_INITS\
\
\
STUCK:	MOV DISPLAY, A		; show display--constant, till interrupt inc's it or dec's it\
	SJMP STUCK					; (responds to falling edge--pseudo-edge sensitive,\
									;   so you must clock several times while high, then low)\
				\
\
;------- INITITALIZATIONS\
;--- SUBROUTINES ----\
USUAL_SETUP: anl   PCA0MD, #NOT(040h)        ; Disable the WDT.\
                                             ; Clear Watchdog Enable bit\
\
				; Configure the Oscillator\
             orl   OSCICN, #04h         ; sysclk = 24.5 Mhz / 8\
\
         ; Enable the Port I/O Crossbar\
\
            mov   XBR1, #40h           ; Enable Crossbar\
						ret\
\
\
; ----NOW ENABLE INTERRUPTS----\
INT_INITS:  \
	mov IT01CF, #0x75;	place the two interrupt requests at P0.5, P0.7\
	mov P0, #0FFh			; disassert both interrupt requests\
  setb IT0		; make INT0 Edge-sensitive	(p. 22)\
  setb IT1		; ditto for INT1\
;  setb PX1		; you can try giving higher priority to INT1 (SFR "IP0", p. 25 of user's guide);\
;                   name is from RIDE list, "IP"...\
  setb EX0		; ...and enable INT0\
  setb EX1		; ...and INT1\
	mov IT01CF, #75h	; SiLabs special: makes both interrupts active-low, places them at P0.7, P0.5\
  setb EA		; Global int enable        (pp.31-32)\
	ret\
\
\
            \
;------------------------------\
; ISR0: This is response to INT ZERO: INCREMENT A\
	ORG INT0VECTOR				; this is defined in VECTORS3210.INC, included above.\
									;  It is address 03h, the address to which micro hops\
									;   in response to interrupt ZERO\
ISR0:	PUSH PSW					; just to demonstrate swapping in a fresh set of scratch registers\
		MOV PSW, #8				; select set #1 of scratch registers (vs #zero used for Main)\
		INC A\
		POP PSW					; restore old set of registers\
		RETI	\
\
; ISR1: This is response to INT ONE: DECREMENT A\
	ORG INT1VECTOR				; this is defined in VECTORS3210.INC, included above.\
									;  It is address 13h, the address to which micro hops\
									;   in response to interrupt ONE\
ISR1:	PUSH PSW					; just to demonstrate swapping in a fresh set of scratch registers\
		MOV PSW, #10h				; select set #2 of scratch registers (vs #zero used for Main #1 for Int0)\
		DEC A\
		POP PSW\
		RETI	\
\
\
END\
	\
	\
}